
#property copyright ""
#property link "http://www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  Gold

//
//
//
//
//

extern string s00             = "--Ma Settings--";
extern int    Ma              = 10;
extern int    MaMode          = MODE_EMA;
extern int    MaPrice         = PRICE_CLOSE;

extern string s01             = "--Ichimoku Settings--";
extern int    Tenkan          = 9;
extern int    Kijun           = 26;
extern int    Senkou          = 52;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double trend[];

//
//
//
//
//

int init()
{

   IndicatorBuffers(4);   
   SetIndexBuffer(0,Buffer1); 
   SetIndexBuffer(1,Buffer2);
   SetIndexBuffer(2,Buffer3);  
   SetIndexBuffer(3,trend); 

return(0);
}

int deinit(){return(0);}

//
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   for(i=limit; i>=0; i--)
   {      
       Buffer1[i] = iMA(NULL,0,Ma,0,MaMode,MaPrice,i);
       Buffer2[i] = iCustom(NULL,0,"Ichimoku",Tenkan,Kijun,Senkou,5,i);
       Buffer3[i] = iCustom(NULL,0,"Ichimoku",Tenkan,Kijun,Senkou,6,i);
         trend[i] = trend[i+1];
           
      if(Buffer1[i] > Buffer2[i] && Buffer1[i+1] <= Buffer2[i+1]) trend[i] = 1;
      if(Buffer1[i] < Buffer3[i] && Buffer1[i+1] >= Buffer3[i+1]) trend[i] =-1;
   }
   
   if (alertsOn)
      {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ichimoku ma cross ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ichimoku ma cross "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}




